declare var image1: Image;

// Menu Class - using popupMenu(), 21 October, 2012, Copyright 2004-2012 Harry Whitfield

//////////////////////////////////////////////////////////////////////////////////////////

class Menu {
    public image: Image;
    public menus: string[];
    public selected: string;
    public menuAction: Function;
    public hOffset: number;
    public vOffset: number;
    
    constructor(menuImage: Image, menuStringsArray: string[], selectedString: string, menuActionFunction: Function) {
    	var i: number;
    
    	this.image = menuImage;
    	this.menus = [];
    	for (i = 0; i < menuStringsArray.length; i += 1) {
    		this.menus[i] = menuStringsArray[i];
    	}
    	this.selected = selectedString;
    	this.menuAction = menuActionFunction;
    	this.hOffset = menuImage.hOffset;
    	this.vOffset = menuImage.vOffset;
    }
	
	reset(menuStringsArray: string[], selectedString: string) {
    	var i: number;
    
		this.menus = null;
		this.menus = [];
    	for (i = 0; i < menuStringsArray.length; i += 1) {
    		this.menus[i] = menuStringsArray[i];
    	}
    	this.selected = selectedString;
    }

	show(opacity: number) {
		this.image.opacity = opacity;
	}

	setTick(selected: string) {
		this.selected = selected;
	}

	select() {
    	var menuItems: MenuItem[] = [], items: string, that = this.menus;
    
    	for (items in that) {
    		if (that.hasOwnProperty(items)) {
        		menuItems[items] = new MenuItem();
        		menuItems[items].title = that[items];
        		menuItems[items].checked = (this.selected === that[items]);
        		menuItems[items].i = items;
        		menuItems[items].data = that[items];
        		menuItems[items].onSelect = this.menuAction;
        	}
    	}
    	popupMenu(menuItems, this.hOffset, this.vOffset);
    	updateNow();
	}
}

//////////////////////////////////////////////////////////////////////////////////////////

var modeMenu: Menu;

function modeMenuAction() { //	(i, data)	// define the action function for modeMenu
    var i: number = this.i, data: string = this.data;
        
    print("Index(i): " + i + " Data: " + data);
    modeMenu.setTick(data);
}

var modeText = ['Coil Diameter', 'Number of Turns', 'Length of Coil', 'Coil Inductance'];

var menuStringsArray   = modeText; 			// define the array of menuStrings
var selectedString 	   = modeText[3];		// define the initially selected string, or set to ""
var menuActionFunction = modeMenuAction;	// define the name of the menuAction function - must be a function
var menuImage = image1;
modeMenu = new Menu(menuImage, menuStringsArray, selectedString, menuActionFunction);	// call the menu constructor

menuImage.onMouseDown = function () {
	if (system.platform === "macintosh") { modeMenu.select(); }
};

menuImage.onMouseUp = function () {
	if (system.platform !== "macintosh") { modeMenu.select(); }
};
