///////////////////////////////////////////////////////////////
/*
class Point {
	constructor(public x: number, public  y: number) { }
}
*/
class Polygon {
    constructor(public vertices: number) { 
    	if ((vertices !== Math.floor(vertices)) || (vertices < 3)) {
    		alert("Invalid vertices: " + vertices);
    	}
    }
    	
	set(vertices: number) {
    	if ((vertices !== Math.floor(vertices)) || (vertices < 3)) {
    		alert("Invalid vertices: " + vertices);
    	}
		this.vertices = vertices;
	}
	get() {
		return this.vertices;
	}
	setPoints(p: Point[]) {
		this.p = p;
	}
	area() {
		if (this.p.length === this.vertices) {
			var sum = 0,
				n = this.p.length,
				j = n - 1,
				i: number;
	
			for (i = 0; i < n; i += 1) {
				sum += (this.p[j].x + this.p[i].x) * (this.p[j].y - this.p[i].y); 
				j = i;
			}
			return Math.abs(0.5 * sum);
		} else {
			alert("Can't calculate area of this polygon");
			return 0;
		}
	}
	
	p: Point[];
}

class Triangle extends Polygon {
	constructor() {
		super(3);
	}
	setPoints(p: Point[]) {
		if (p.length !== 3) {
			alert("triangles must be specified by three points: " + p.length);
		}
		super.setPoints(p);
	}
	area() {
		if (this.p.length === 3) {
			return super.area()
//			return 0.5 * Math.abs(this.p[0].x * (this.p[1].y - this.p[2].y) + this.p[1].x * (this.p[2].y - this.p[0].y) + this.p[2].x * (this.p[0].y - this.p[1].y));
		} else {
			alert("Can't calculate area of this triangle");
			return 0;
		}
	}
}

class MyRectangle extends Polygon {
	constructor() {
		super(4);
	}
	setPoints(p: Point[]) {
		if (p.length !== 2) {
			alert("rectangles must be specified by two points: " + p.length);
		}
		super.setPoints(p);
	}
	area() {
		if (this.p.length === 2) {
			return Math.abs((this.p[0].x - this.p[1].x) * (this.p[0].y - this.p[1].y));
		} else {
			alert("Can't calculate area of this rectangle/square");
			return 0;
		}
	}
}

class Square extends MyRectangle {
	constructor() {
		super();
	}
	setPoints(p: Point[]) {
		if (p.length !== 2) {
			alert("squares must be specified by two points: " + p.length);
		} else if (Math.abs(p[0].x - p[1].x) !== Math.abs(p[0].y - p[1].y)) {
			alert("squares must have equal sides");
		}
		super.setPoints(p);
	}
}

print("\n-----");

var poly = new Polygon(5);
var vert = poly.get();
print("poly vertices: " + vert);
poly.setPoints([new Point(0, 0), new Point(0, 15), new Point(10, 15), new Point(5, 7.5), new Point(10, 0)]);
print("polygon area: " + poly.area());

print("-----");

poly.set(4);
vert = poly.get();
print("poly vertices: " + vert);
poly.setPoints([new Point(0, 0), new Point(0, 15), new Point(10, 15), new Point(10, 0)]);
print("polygon area: " + poly.area());

print("-----");

//poly.set(2);

var triangle = new Triangle();
vert = triangle.get();
print("triangle vertices: " + vert);
//triangle.setPoints([new Point(0, 0), new Point(10, 10)]);
triangle.setPoints([new Point(0, 0), new Point(10, 10), new Point(0, 10)]);	// must give three points
print("triangle area: " + triangle.area());

print("-----");

var rectangle = new MyRectangle();
vert = rectangle.get();
print("rectangle vertices: " + vert);
//rectangle.setPoints([new Point(0, 0), new Point(10, 15), new Point(0, 10)]);	// must give two points
rectangle.setPoints([new Point(0, 0), new Point(10, 15)]);	// must give two points
print("rectangle area: " + rectangle.area());

print("-----");

var square = new Square();	// must give two points
vert = square.get();
print("square vertices: " + vert);
square.setPoints([new Point(0, 0), new Point(11, 11)]);		// must give two points
//square.setPoints([new Point(0, 0), new Point(10, 15), new Point(0, 10)]);	// must give two points
print("square area: " + square.area());
